package soap;

import java.io.ByteArrayOutputStream;
import java.util.List;

import javax.xml.soap.*;

public class SOAPUtil {

    private static String host = "http://api.m.lekseek.com";
    private static String service = "/index.php";
    private static String mns = "m.lekseek.com";
    
    public static String callSOAPRequset(SOAPMessage msg) throws Exception {
         SOAPConnectionFactory soapConnectionFactory = SOAPConnectionFactory.newInstance();
         SOAPConnection soapConnection = soapConnectionFactory.createConnection();
         SOAPMessage soapResponse = soapConnection.call(msg, host+service);
         soapConnection.close();
         ByteArrayOutputStream out = new ByteArrayOutputStream();
         soapResponse.writeTo(out);
         String strMsg = new String(out.toByteArray());
         return strMsg;
    }
    
    public static SOAPMessage createSOAPRequest(String clientAuthCode, String method, List<Param> params) throws Exception {
        MessageFactory myMsgFct = MessageFactory.newInstance();
        SOAPMessage message = myMsgFct.createMessage();
        SOAPPart mySPart = message.getSOAPPart();
        SOAPEnvelope myEnvp = mySPart.getEnvelope();
        SOAPBody body = myEnvp.getBody();
        Name bodyName = myEnvp.createName(method, "mns", mns);
        SOAPBodyElement gltp = body.addBodyElement(bodyName);
        for(Param p : params) {
            Name myContent = myEnvp.createName(p.getName());
            SOAPElement mySymbol = gltp.addChildElement(myContent);
            mySymbol.addTextNode(p.getValue());	
        }
        message.saveChanges();
        return message;
    }

}